// Generated with EntitiesToDTOs.v2.1 (entitiestodtos.codeplex.com).
// Timestamp: 24/10/2012 - 14:22:18
using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Text;
using System.Linq;

namespace UnboundColumnUpdatingHierarchy.Models
{

    /// <summary>
    /// Assembler for <see cref="Employee"/> and <see cref="EmployeeDTO"/>.
    /// </summary>
    public static partial class EmployeeAssembler
    {
        /// <summary>
        /// Invoked when <see cref="ToDTO"/> operation is about to return.
        /// </summary>
        /// <param name="dto"><see cref="EmployeeDTO"/> converted from <see cref="Employee"/>.</param>
        static partial void OnDTO(this Employee entity, EmployeeDTO dto);

        /// <summary>
        /// Invoked when <see cref="ToEntity"/> operation is about to return.
        /// </summary>
        /// <param name="entity"><see cref="Employee"/> converted from <see cref="EmployeeDTO"/>.</param>
        static partial void OnEntity(this EmployeeDTO dto, Employee entity);

        /// <summary>
        /// Converts this instance of <see cref="EmployeeDTO"/> to an instance of <see cref="Employee"/>.
        /// </summary>
        /// <param name="dto"><see cref="EmployeeDTO"/> to convert.</param>
        public static Employee ToEntity(this EmployeeDTO dto)
        {
            if (dto == null) return null;

            Employee entity = null;

            entity = new Employee();

            entity.BusinessEntityID = dto.BusinessEntityID;
            entity.NationalIDNumber = dto.NationalIDNumber;
            entity.LoginID = dto.LoginID;
            entity.OrganizationLevel = dto.OrganizationLevel;
            entity.JobTitle = dto.JobTitle;
            entity.BirthDate = dto.BirthDate;
            entity.MaritalStatus = dto.MaritalStatus;
            entity.Gender = dto.Gender;
            entity.HireDate = dto.HireDate;
            entity.SalariedFlag = dto.SalariedFlag;
            entity.VacationHours = dto.VacationHours;
            entity.SickLeaveHours = dto.SickLeaveHours;
            entity.CurrentFlag = dto.CurrentFlag;
            entity.rowguid = dto.rowguid;
            entity.ModifiedDate = dto.ModifiedDate;

            dto.OnEntity(entity);

            return entity;
        }

        /// <summary>
        /// Converts this instance of <see cref="Employee"/> to an instance of <see cref="EmployeeDTO"/>.
        /// </summary>
        /// <param name="entity"><see cref="Employee"/> to convert.</param>
        public static EmployeeDTO ToDTO(this Employee entity)
        {
            if (entity == null) return null;

            EmployeeDTO dto = null;

            dto = new EmployeeDTO();

            dto.BusinessEntityID = entity.BusinessEntityID;
            dto.NationalIDNumber = entity.NationalIDNumber;
            dto.LoginID = entity.LoginID;
            dto.OrganizationLevel = entity.OrganizationLevel;
            dto.JobTitle = entity.JobTitle;
            dto.BirthDate = entity.BirthDate;
            dto.MaritalStatus = entity.MaritalStatus;
            dto.Gender = entity.Gender;
            dto.HireDate = entity.HireDate;
            dto.SalariedFlag = entity.SalariedFlag;
            dto.VacationHours = entity.VacationHours;
            dto.SickLeaveHours = entity.SickLeaveHours;
            dto.CurrentFlag = entity.CurrentFlag;
            dto.rowguid = entity.rowguid;
            dto.ModifiedDate = entity.ModifiedDate;
            dto.DepartmentID = entity.EmployeeDepartmentHistories.FirstOrDefault().DepartmentID;
            dto.Person_BusinessEntityID = entity.Person.BusinessEntityID;

            entity.OnDTO(dto);

            return dto;
        }
    }
}
